#include <stdio.h>
#include "board.h"

/*
 * KnightMove
 * Chess Board, Printing & Test Functions
 */

int solution[64][2] = {
 {1,3}, {3,4}, {5,5}, {7,6}, {8,8}, {6,7}, {4,8}, {5,6},
 {3,7}, {1,8}, {2,6}, {4,5}, {6,4}, {8,3}, {7,5}, {8,7},
 {6,8}, {4,7}, {2,8}, {1,6}, {3,5}, {5,4}, {7,3}, {8,1},
 {6,2}, {4,1}, {5,3}, {7,2}, {8,4}, {6,3}, {7,1}, {5,2},
 {3,1}, {1,2}, {2,4}, {3,6}, {1,5}, {2,7}, {4,6}, {5,8},
 {7,7}, {8,5}, {6,6}, {7,4}, {8,2}, {6,1}, {4,2}, {2,1},
 {3,3}, {1,4}, {2,2}, {4,3}, {5,1}, {3,2}, {1,1}, {2,3},
 {4,4}, {6,5}, {8,6}, {7,8}, {5,7}, {3,8}, {1,7}, {2,5}};

int legal_moves[][2] = {
                         {+2, +1},
                         {+1, +2},
                         {-2, -1},
                         {-2, +1},
                         {+1, -2},
                         {+2, -1},
                         {-1, +2},
                         {-1, -2}
                        };

int chess_board[9][9]; // 9x9 So 8x8 Grid Uses Correct Coordinates

int countReverses(int v1, int v2, int v3, int v4, int v5, int v6, int v7, int v8) {
  int r = 0;
  r += ISREVERSE(v1, v2);
  r += ISREVERSE(v1, v3);
  r += ISREVERSE(v1, v4);
  r += ISREVERSE(v1, v5);
  r += ISREVERSE(v1, v6);
  r += ISREVERSE(v1, v7);
  r += ISREVERSE(v1, v8);
  r += ISREVERSE(v2, v3);
  r += ISREVERSE(v2, v4);
  r += ISREVERSE(v2, v5);
  r += ISREVERSE(v2, v6);
  r += ISREVERSE(v2, v7);
  r += ISREVERSE(v2, v8);
  r += ISREVERSE(v3, v4);
  r += ISREVERSE(v3, v5);
  r += ISREVERSE(v3, v6);
  r += ISREVERSE(v3, v7);
  r += ISREVERSE(v3, v8);
  r += ISREVERSE(v4, v5);
  r += ISREVERSE(v4, v6);
  r += ISREVERSE(v4, v7);
  r += ISREVERSE(v4, v8);
  r += ISREVERSE(v5, v6);
  r += ISREVERSE(v5, v7);
  r += ISREVERSE(v5, v8);
  r += ISREVERSE(v6, v7);
  r += ISREVERSE(v6, v8);
  r += ISREVERSE(v7, v8);
  return r;
}

int countSquares(int v1, int v2, int v3, int v4, int v5, int v6, int v7, int v8) {
  int count = 0;

  count += ISSQUARE(v1) ? 1 : 0;
  count += ISSQUARE(v2) ? 1 : 0;
  count += ISSQUARE(v3) ? 1 : 0;
  count += ISSQUARE(v4) ? 1 : 0;
  count += ISSQUARE(v5) ? 1 : 0;
  count += ISSQUARE(v6) ? 1 : 0;
  count += ISSQUARE(v7) ? 1 : 0;
  count += ISSQUARE(v8) ? 1 : 0;

  return count;
}

int countCubes(int v1, int v2, int v3, int v4, int v5, int v6, int v7, int v8) {
  int count = 0;

  count += ISCUBE(v1) ? 1 : 0;
  count += ISCUBE(v2) ? 1 : 0;
  count += ISCUBE(v3) ? 1 : 0;
  count += ISCUBE(v4) ? 1 : 0;
  count += ISCUBE(v5) ? 1 : 0;
  count += ISCUBE(v6) ? 1 : 0;
  count += ISCUBE(v7) ? 1 : 0;
  count += ISCUBE(v8) ? 1 : 0;

  return count;
}

int countMultiples(int multiple, int v1, int v2, int v3, int v4, int v5, int v6, int v7, int v8) {
  int count = 0;

  count += (v1 % multiple) == 0 ? 1 : 0;
  count += (v2 % multiple) == 0 ? 1 : 0;
  count += (v3 % multiple) == 0 ? 1 : 0;
  count += (v4 % multiple) == 0 ? 1 : 0;
  count += (v5 % multiple) == 0 ? 1 : 0;
  count += (v6 % multiple) == 0 ? 1 : 0;
  count += (v7 % multiple) == 0 ? 1 : 0;
  count += (v8 % multiple) == 0 ? 1 : 0;

  return count;
}

int countDivisibles(int divisible, int v1, int v2, int v3, int v4, int v5, int v6, int v7, int v8) {
  int count = 0;

  count += (v1 % divisible) == 0 ? 1 : 0;
  count += (v2 % divisible) == 0 ? 1 : 0;
  count += (v3 % divisible) == 0 ? 1 : 0;
  count += (v4 % divisible) == 0 ? 1 : 0;
  count += (v5 % divisible) == 0 ? 1 : 0;
  count += (v6 % divisible) == 0 ? 1 : 0;
  count += (v7 % divisible) == 0 ? 1 : 0;
  count += (v8 % divisible) == 0 ? 1 : 0;

  return count;
}

int countRange(int min, int max, int v1, int v2, int v3, int v4, int v5, int v6, int v7, int v8) {
  int count = 0;

  count += ((min <= v1) && (max >= v1)) ? 1 : 0;
  count += ((min <= v2) && (max >= v2)) ? 1 : 0;
  count += ((min <= v3) && (max >= v3)) ? 1 : 0;
  count += ((min <= v4) && (max >= v4)) ? 1 : 0;
  count += ((min <= v5) && (max >= v5)) ? 1 : 0;
  count += ((min <= v6) && (max >= v6)) ? 1 : 0;
  count += ((min <= v7) && (max >= v7)) ? 1 : 0;
  count += ((min <= v8) && (max >= v8)) ? 1 : 0;

  return count;
}

int testBoardComplete() {
  int v1, v2, v3, v4, v5, v6, v7, v8;

  // Across 1 - Nothing > 55
  v1 = chess_board[1][1]; v2 = chess_board[2][1]; v3 = chess_board[3][1]; v4 = chess_board[4][1];
  v5 = chess_board[5][1]; v6 = chess_board[6][1]; v7 = chess_board[7][1]; v8 = chess_board[8][1];

  if(countRange(56, 64, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Across 2 - 1 Square Number, Nothing < 20, 2 Multiples Of 17
  v1 = chess_board[1][2]; v2 = chess_board[2][2]; v3 = chess_board[3][2]; v4 = chess_board[4][2];
  v5 = chess_board[5][2]; v6 = chess_board[6][2]; v7 = chess_board[7][2]; v8 = chess_board[8][2];

  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countRange(1, 19, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }
  if(countMultiples(17, v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }

  // Across 3 - 2 Cube Numbers, 2 Square Numbers, 3 Multiples Of 7
  v1 = chess_board[1][3]; v2 = chess_board[2][3]; v3 = chess_board[3][3]; v4 = chess_board[4][3];
  v5 = chess_board[5][3]; v6 = chess_board[6][3]; v7 = chess_board[7][3]; v8 = chess_board[8][3];

  if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countMultiples(7, v1, v2, v3, v4, v5, v6, v7, v8) != 3) {
    return 0;
  }

  // Across 4 - Nothing Divisible By 8 Or 12
  v1 = chess_board[1][4]; v2 = chess_board[2][4]; v3 = chess_board[3][4]; v4 = chess_board[4][4];
  v5 = chess_board[5][4]; v6 = chess_board[6][4]; v7 = chess_board[7][4]; v8 = chess_board[8][4];

  if(countDivisibles(8, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }
  if(countDivisibles(12, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Across 5 - 1 Cube, 1 Square, 2 Multiples 21, Nothing Divisible By 13
  v1 = chess_board[1][5]; v2 = chess_board[2][5]; v3 = chess_board[3][5]; v4 = chess_board[4][5];
  v5 = chess_board[5][5]; v6 = chess_board[6][5]; v7 = chess_board[7][5]; v8 = chess_board[8][5];

  if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countMultiples(21, v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countDivisibles(13, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Across 6 - 1 Cube, 2 Squares, Nothing Greater Than 60
  v1 = chess_board[1][6]; v2 = chess_board[2][6]; v3 = chess_board[3][6]; v4 = chess_board[4][6];
  v5 = chess_board[5][6]; v6 = chess_board[6][6]; v7 = chess_board[7][6]; v8 = chess_board[8][6];

  if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countRange(61, 64, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Across 7 - 2 Squares, 1 Number Is 7 * Another
  v1 = chess_board[1][7]; v2 = chess_board[2][7]; v3 = chess_board[3][7]; v4 = chess_board[4][7];
  v5 = chess_board[5][7]; v6 = chess_board[6][7]; v7 = chess_board[7][7]; v8 = chess_board[8][7];

  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }

  int count7 = 0;

  for(int i = 1; i < 8; i++) {
    for(int j = i+1; j < 9; j++) {
      if(chess_board[i][7] == 7 * chess_board[j][7]) {
        count7++;
      } else if(chess_board[j][7] == 7 * chess_board[i][7]) {
        count7++;
      }
    }
  }

  if(count7 != 1) {
    return 0;
  }

  // Across 8 - 2 Multiples Of 20, 1 Multiple Of 17
  v1 = chess_board[1][8]; v2 = chess_board[2][8]; v3 = chess_board[3][8]; v4 = chess_board[4][8];
  v5 = chess_board[5][8]; v6 = chess_board[6][8]; v7 = chess_board[7][8]; v8 = chess_board[8][8];

  if(countMultiples(20, v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countMultiples(17, v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }

  // Down 1 - 1 Cube, 1 Square, Nothing Between 20 & 30
  v1 = chess_board[1][1]; v2 = chess_board[1][2]; v3 = chess_board[1][3]; v4 = chess_board[1][4];
  v5 = chess_board[1][5]; v6 = chess_board[1][6]; v7 = chess_board[1][7]; v8 = chess_board[1][8];

  if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countRange(21, 29, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Down 2 - 1 Cube, 1 Square, 2 Mutiples Of 19, Nothing Below 10
  v1 = chess_board[2][1]; v2 = chess_board[2][2]; v3 = chess_board[2][3]; v4 = chess_board[2][4];
  v5 = chess_board[2][5]; v6 = chess_board[2][6]; v7 = chess_board[2][7]; v8 = chess_board[2][8];

  if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countMultiples(19, v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countRange(1, 9, v1, v2, v3, v4, v5, v6, v7, v8) != 0) {
    return 0;
  }

  // Down 3 - 3 Squares, 2 Multiples Of 18
  v1 = chess_board[3][1]; v2 = chess_board[3][2]; v3 = chess_board[3][3]; v4 = chess_board[3][4];
  v5 = chess_board[3][5]; v6 = chess_board[3][6]; v7 = chess_board[3][7]; v8 = chess_board[3][8];

  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 3) {
    return 0;
  }
  if(countMultiples(18, v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }

  // Down 4 - 3 Multiples Of 13, 1 Multiple Of 18
  v1 = chess_board[4][1]; v2 = chess_board[4][2]; v3 = chess_board[4][3]; v4 = chess_board[4][4];
  v5 = chess_board[4][5]; v6 = chess_board[4][6]; v7 = chess_board[4][7]; v8 = chess_board[4][8];

  if(countMultiples(13, v1, v2, v3, v4, v5, v6, v7, v8) != 3) {
    return 0;
  }
  if(countMultiples(18, v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }

  // Down 5 - 2 Cubes, Nothing Between 40 & 50
  v1 = chess_board[5][1]; v2 = chess_board[5][2]; v3 = chess_board[5][3]; v4 = chess_board[5][4];
  v5 = chess_board[5][5]; v6 = chess_board[5][6]; v7 = chess_board[5][7]; v8 = chess_board[5][8];

  if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) != 2) {
    return 0;
  }
  if(countRange(41, 49, v1, v2, v3, v4, v5, v6, v7, v8) != 0) {
    return 0;
  }

  // Down 6 - 1 Square, Nothing Divisible By 4 Or 9
  v1 = chess_board[6][1]; v2 = chess_board[6][2]; v3 = chess_board[6][3]; v4 = chess_board[6][4];
  v5 = chess_board[6][5]; v6 = chess_board[6][6]; v7 = chess_board[6][7]; v8 = chess_board[6][8];

  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countDivisibles(4, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }
  if(countDivisibles(9, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Down 7 - 1 Square, 4 Multiples Of 4, Nothing Divisible By 9
  v1 = chess_board[7][1]; v2 = chess_board[7][2]; v3 = chess_board[7][3]; v4 = chess_board[7][4];
  v5 = chess_board[7][5]; v6 = chess_board[7][6]; v7 = chess_board[7][7]; v8 = chess_board[7][8];

  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if(countMultiples(4, v1, v2, v3, v4, v5, v6, v7, v8) != 4) {
    return 0;
  }
  if(countDivisibles(9, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
    return 0;
  }

  // Down 8 - 1 Square, 1 Number Reverse Of Another, Total Equals 234
  v1 = chess_board[8][1]; v2 = chess_board[8][2]; v3 = chess_board[8][3]; v4 = chess_board[8][4];
  v5 = chess_board[8][5]; v6 = chess_board[8][6]; v7 = chess_board[8][7]; v8 = chess_board[8][8];

  if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }
  if((v1 + v2 + v3 + v4 + v5 + v6 + v7 + v8) != 234) {
    return 0;
  }
  if(countReverses(v1, v2, v3, v4, v5, v6, v7, v8) != 1) {
    return 0;
  }

  // Finally, Check 64 Is One Move From 1
  for(int x = 1; x <= 8; x++) {
    for(int y = 1; y <= 8; y++) {
      if(chess_board[x][y] == 64) {
        for(int i = 0; i < 8; i++) {
          if(LEGALSQUARE(x+legal_moves[i][0], y+legal_moves[i][1])) {
            if(chess_board[x+legal_moves[i][0]][y+legal_moves[i][1]] == 1) {
              return 1;
            }
          }
        }
      }
    }
  }

  return 0;
}

// A Few Quick Tests - testBoardComplete() Has More!
int testBoardPartial() {
  if(testBoardPartialLine(1, 1)) {
    if(testBoardPartialLine(2, 2)) {
      if(testBoardPartialLine(3, 3)) {
        if(testBoardPartialLine(4, 4)) {
          if(testBoardPartialLine(5, 5)) {
            if(testBoardPartialLine(6, 6)) {
              if(testBoardPartialLine(7, 7)) {
                if(testBoardPartialLine(8, 8)) {
                  return 1;
                }
              }
            }
          }
        }
      }
    }
  }
  return 0;
}

// A Few Quick Tests - testBoardComplete() Has More!
int testBoardPartialLine(int col, int row) {
  int v1, v2, v3, v4, v5, v6, v7, v8;

  v1 = chess_board[1][row]; v2 = chess_board[2][row]; v3 = chess_board[3][row]; v4 = chess_board[4][row];
  v5 = chess_board[5][row]; v6 = chess_board[6][row]; v7 = chess_board[7][row]; v8 = chess_board[8][row];

  switch(row) {
    case 1:
      // Across 1 - Nothing > 55
      if(countRange(56, 64, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      break;

    case 2:
      // Across 2 - 1 Square Number, Nothing Below 20 & 2 Multiples 17
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countRange(1, 19, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      if(countMultiples(17, v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      break;

    case 3:
      // Across 3 - 2 Cube Numbers, 2 Square Numbers, 3 Multiples 7
      if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      if(countMultiples(7, v1, v2, v3, v4, v5, v6, v7, v8) > 3) {
        return 0;
      }
      break;

    case 4:
      // Across 4 - Nothing Divisible By 8 Or 12
      if(countDivisibles(8, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      if(countDivisibles(12, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      break;

    case 5:
      // Across 5 - 1 Cube, 1 Square, 2 Mutiples(21), No Divisibles(13)
      if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countMultiples(21, v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      if(countDivisibles(13, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }   
      break;

    case 6:
      // Across 6 - 1 Cube, 2 Squares, Nothing > 60
      if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      if(countRange(61, 64, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      break;

    case 7:
      // Across 7 - 2 Squares
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      break;

    case 8:
      // Across 8 - 2 Multiples Of 20
      if(countMultiples(20, v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      break;
  }

  v1 = chess_board[col][1]; v2 = chess_board[col][2]; v3 = chess_board[col][3]; v4 = chess_board[col][4];
  v5 = chess_board[col][5]; v6 = chess_board[col][6]; v7 = chess_board[col][7]; v8 = chess_board[col][8];

  switch(col) {
    case 1:
      // Down 1 - 1 Cube, 1 Square, Nothing Between 20 & 30
      if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countRange(21, 29, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      break;

    case 2:
      // Down 2 - 1 Cube, 1 Square, Nothing < 10
      if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countRange(1, 9, v1, v2, v3, v4, v5, v6, v7, v8) > 0) {
        return 0;
      }
      break;

    case 3:
      // Down 3 - 3 Squares
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 3) {
        return 0;
      }
      break;

    case 4:
      // Down 4 - 3 Multiples Of 13, 1 Multiple Of 18
      if(countMultiples(13, v1, v2, v3, v4, v5, v6, v7, v8) > 3) {
        return 0;
      }
      if(countMultiples(18, v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      break;

    case 5:
      // Down 5 - 2 Cubes
      if(countCubes(v1, v2, v3, v4, v5, v6, v7, v8) > 2) {
        return 0;
      }
      break;

    case 6:
      // Down 6 - 1 Square
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      break;

    case 7:
      // Down 7 - 1 Square
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      break;

    case 8:
      // Down 8 - 1 Square & 1 Reverse Pair
      if(countSquares(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      if(countReverses(v1, v2, v3, v4, v5, v6, v7, v8) > 1) {
        return 0;
      }
      break;
  }

  return 1;
}

void printBoard() {
  printf("   1  2  3  4  5  6  7  8\n");

  for(int y = 1; y < 9; y++) {
    printf("%d ", y);
    for(int x = 1; x < 9; x++) {
      printf("%2d ", chess_board[x][y]);
    }

    printf("\n");
  }

  printf("\n");
}

void clearBoard() {
  for(int y = 1; y < 9; y++) {
    for(int x = 1; x < 9; x++) {
      chess_board[x][y] = -1;
    }
  }
}

#ifdef TESTBOARD
int main(int argc, char **argv) {
  int partialcount = 0;
  int linecount = 0;

  clearBoard();

  for(int i = 0; i < 64; i++) {
    chess_board[solution[i][0]][solution[i][1]] = i+1;
    partialcount += testBoardPartial();
    linecount += testBoardPartialLine(solution[i][0], solution[i][1]);
  }

  if(testBoardComplete()) {
    printf("Passed testBoardComplete()\n");
  } else {
    printf("Failed testBoardComplete()\n");
  }

  if(testBoardPartial() && partialcount == 64) {
    printf("Passed testBoardPartial()\n");
  } else {
    printf("Failed testBoardPartial()\n");
  }

  if(linecount == 64) {
    printf("Passed testBoardPartialLine()\n");
  } else {
    printf("Failed testBoardPartialLine()\n");
  }

  return 0;
}

/*
   1  2  3  4  5  6  7  8
1 55 48 33 26 53 46 31 24
2 34 51 54 47 32 25 28 45
3  1 56 49 52 27 30 23 14
4 50 35  2 57 22 13 44 29
5 37 64 21 12  3 58 15 42
6 20 11 36 39  8 43  4 59
7 63 38  9 18 61  6 41 16
8 10 19 62  7 40 17 60  5
*/
#endif
