#include <stdio.h>
#include "board.h"

/*
 * Program to solve number puzzle on chess board, based on moves of a knight
 */

#define CUBE_64_X 2
#define CUBE_64_Y 5

int testMove(int c, int x, int y) {
  if(LEGALSQUARE(x, y)) {
    if(chess_board[x][y] == -1) {
      if(ISCUBE(c)) {
        if(x != 1 && x != 2 && x != 5) {
          return 0;
        }
        if(y != 3 && y != 5 && y != 6) {
          return 0;
        }
      }

      if(ISSQUARE(c)) {
        if(x != 1 && x != 2 && x != 3 && x != 6 && x != 7 && x != 8) {
          return 0;
        }
        if(y != 2 && y != 3 && y != 5 && y != 6 && y != 7) {
          return 0;
        }
      }

      if((c % 18) == 0) {
        if(x != 3 && x != 4) {
          return 0;
        }
      }

      if((c % 17) == 0) {
        if(y != 2 && y != 8) {
          return 0;
        }
      }

      if((c % 9) == 0) {
        if((x == 6) || (x == 7)) {
          return 0;
        }
      }

      if((c % 4) == 0) {
        if(x == 6) {
          return 0;
        }
      }

      if(c > 55) {
        if(y == 1) {
          return 0;
        } else if(c > 60) {
          if(y == 6) {
            return 0;
          }
        }
      }

      if(c < 20) {
        if(y == 2) {
          return 0;
        } else if(c < 10) {
          if(x == 2) {
            return 0;
          }
        }
      }

      return 1;
    }
  }

  return 0;
}


void updateBoard(int c, int x, int y) {
  if(testMove(c, x, y)) {
    chess_board[x][y] = c;

    if(c < 64) {
      if(testBoardPartialLine(x, y)) {
        for(int i = 0; i < 8; i++) {
          updateBoard(c+1, x+legal_moves[i][0], y+legal_moves[i][1]);
        }
      }
    } else {
      if(testBoardComplete()) {
        printf("Solution:\n");
        printBoard();
        exit(0);
      }
    }

    chess_board[x][y] = -1;
  }
}

int main(int argc, char **argv) {
  clearBoard();
  updateBoard(1, START_X, START_Y);
  return 1;
}
